Skip to content

Overview

  • Version: 2.0.0
  • Servers: https://store.xsolla.com/api
  • Contact Us by Email
  • Contact URL: https://xsolla.com/
  • Required TLS version: 1.2

Shop Builder API provides a third-party solution for implementing the server side for your store interface. Use the endpoints to manage in-game items, in-game currencies, cart, player inventory, promotions, game library, etc.

Download OpenAPI description
Languages
Servers
Mock server
https://xsolla.redocly.app/_mock/api/shop-builder/
https://store.xsolla.com/api/
Operations

Personalized catalog

This API allows to specify rules for user attributes. If the user meets all conditions for a concrete rule, personalized items will be shown.

For personalized promotions see Promotions section.

To pass attributes before a purchase, you can use Xsolla Login API or pass them into user.attributes property while generating token using Pay Station API.

Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations

Catalog

This API allows getting any kind of sellable items or specific item.

Operations
Operations
Operations
Operations
Operations
Operations

Coupons

This API allows to you to manage coupons.

Operations

Request

Redeems a coupon code. The user gets a bonus after a coupon is redeemed.

Security
XsollaLoginUserJWT
Path
project_idintegerrequired

Project ID. You can find this parameter in your Publisher Account next to the name of the project.

Example: 44056
Bodyapplication/json
coupon_codestring[ 1 .. 128 ] characters

Unique coupon code. Contains letters and numbers.

Default "WINTER2021"
Example: "WINTER2021"
selected_unit_itemsobject(Promotions_selected_unit_items)

The reward that is selected by a user. Object key is an SKU of a unit, and value is an SKU of one of the items in a unit.

Example: {"game_1":"game_1_steam","game_2":"game_2_playstation"}
curl -i -X POST \
  https://xsolla.redocly.app/_mock/api/shop-builder/v2/project/44056/coupon/redeem \
  -H 'Authorization: Bearer <YOUR_JWT_HERE>' \
  -H 'Content-Type: application/json' \
  -d '{
    "coupon_code": "WINTER2021",
    "selected_unit_items": {
      "game_1": "game_1_steam",
      "game_2": "game_2_playstation"
    }
  }'

Responses

Coupon was successfully redeemed.

Bodyapplication/json
itemsArray of objects
Example: [{"attributes":[],"description":"Take it, take it all! All of Xsolla's riches in one Mega Booster.","groups":[{"external_id":"powerups","name":"Power Ups"}],"image_url":"https://cdn.xsolla.net/img/misc/images/e9f2f4a634bc96ea03b5d5ceadd7c55f.png","is_free":false,"name":"Xsolla Booster Mega","price":{"amount":"50.0000000000000000","amount_without_discount":"100.0000000000000000","currency":"USD"},"quantity":1,"sku":"com.xsolla.booster_mega_1","type":"virtual_good","virtual_item_type":"consumable","virtual_prices":[]}]
Response
application/json
{ "items": [ {} ] }

Request

Gets coupons rewards by its code. Can be used to allow users to choose one of many items as a bonus. The usual case is choosing a DRM if the coupon contains a game as a bonus (type=unit).

Security
XsollaLoginUserJWT
Path
project_idintegerrequired

Project ID. You can find this parameter in your Publisher Account next to the name of the project.

Example: 44056
coupon_codestring[ 1 .. 128 ] charactersrequired

Unique case sensitive code. Contains letters and numbers.

Example: WINTER2021
curl -i -X GET \
  https://xsolla.redocly.app/_mock/api/shop-builder/v2/project/44056/coupon/code/WINTER2021/rewards \
  -H 'Authorization: Bearer <YOUR_JWT_HERE>'

Responses

List of coupon rewards was successfully received.

Bodyapplication/json
bonusArray of objects(Promotions_200-coupon-bonus-reward)
is_selectableboolean

If true, the user should choose the bonus before redeeming a coupon.

discountobject or null(Promotions_200-coupon-discount-reward)

Percent discount. The price of cart will be decreased using a value calculated by using this percent and then rounded to 2 decimal places.

Response
application/json
{ "bonus": [ {}, {} ], "discount": { "percent": "10.00" }, "is_selectable": true }

Create coupon promotionServer-sideAdmin

Request

Creates a coupon promotion.

Security
basicAuth
Path
project_idintegerrequired

Project ID. You can find this parameter in your Publisher Account next to the name of the project.

Example: 44056
Bodyapplication/json
external_idstring(Promotions_coupon-external_id)required

Unique promotion ID. The external_id may contain only lowercase and uppercase Latin alphanumeric characters, periods, dashes, and underscores.

Default "coupon_external_id"
Example: "coupon_external_id"
promotion_periodsArray of objects(promotion_periods)

Promotion validity periods. If multiple periods are specified, both date_from and date_until are required.

nameobject(Promotions_coupon_name)required

Name of promotion. Should contain key/value pairs where key is a locale with "^[a-z]{2}-[A-Z]{2}$" format, value is string.

Default {"en-US":"Coupon title","de-DE":"Gutscheintitel"}
Example: {"en-US":"Coupon title","de-DE":"Gutscheintitel"}
name.​property name*stringadditional property
bonusArray of objects or null(Promotions_coupon_bonus)
redeem_total_limitinteger or null(Promotions_coupon-redeem_total_limit)

Limits total numbers of coupons.

Default 10
Example: 10
redeem_user_limitinteger or null(Promotions_coupon-redeem_user_limit)

Limits total numbers of coupons redeemed by single user.

Default 10
Example: 10
redeem_code_limitinteger or null(Promotions_redeem_code_limit)

Number of redemptions per code.

Default 10
Example: 10
attribute_conditionsArray of type = string (object) or type = number (object) or type = date (object)(promotion_user-attribute_conditions_model-post)[ 1 .. 100 ] items

Conditions for validating user attributes. Determine promotion availability based on whether user attributes match all specified conditions.

curl -i -X POST \
  -u <username>:<password> \
  https://xsolla.redocly.app/_mock/api/shop-builder/v3/project/44056/admin/coupon \
  -H 'Content-Type: application/json' \
  -d '{
    "external_id": "coupon_external_id",
    "promotion_periods": [
      {
        "date_from": "2020-04-15T18:16:00+05:00",
        "date_until": "2020-04-25T18:16:00+05:00"
      },
      {
        "date_from": "2020-05-15T18:16:00+05:00",
        "date_until": "2020-05-25T18:16:00+05:00"
      }
    ],
    "name": {
      "en-US": "New Year Bonus",
      "de-DE": "Neujahrsbonus"
    },
    "redeem_total_limit": 100,
    "redeem_user_limit": 1,
    "redeem_code_limit": 1,
    "bonus": [
      {
        "sku": "com.xsolla.elven_sword_1",
        "quantity": 1
      }
    ]
  }'

Responses

Coupon was successfully created.

Bodyapplication/json
external_idstring(Promotions_coupon-external_id)

Unique promotion ID. The external_id may contain only lowercase and uppercase Latin alphanumeric characters, periods, dashes, and underscores.

Default "coupon_external_id"
Example: "coupon_external_id"
Response
application/json
{ "external_id": "coupon_external_id" }

Promo codes

This API allows to manage promo codes.

Operations

Unique catalog offers

This API allows to you to manage unique catalog offers.

Operations

Discounts

This API allows to you to manage discount promotions.

Operations

Bonuses

This API allows to manage bonus promotions.

Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations